#!/usr/bin/perl -w
#...................................................................#
# Sanitarium WebLoG: web publish system.............................#
# Author: Green Kakadu (WebScript.Ru Network) ......................#
# Email: gnezdo@webscript.ru .......................................#
# WWW: http://webscript.ru .........................................#
# Copyright 2002 WebScript.Ru Network ( http://webscript.ru ).......#
# All Rights Reserved. .............................................#
#...................................................................#
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars '$time_view','$script_admin', '$ext', '$img_url', '$tmpl_dir', '$data', '$public_dir', '$use_emoticons', '$public_url', '$use_flock', '$dir', '%msg', '%in', '$builder',
'$index_url', '$index_page', '$entry_per_page', '$static_pages', '$view_cgi_url', '$site_title', '$how_news', '$use_search', '$not_found', '$foto_url',
'$premoderate', '$send_new_comments', '$admin_mail', '$SEND_MAIL', '$comadmin_cgi_url', '$comment_url', '$mail_cgi_url', '$coms_per_page', '$foto_dir', '$img_dir', '$GMT', '$upload_url', '$validate_db', '$autolink',
'$qhtml', '$fozzy', '$txt_news';

#....Load Libraries 
eval { 
require "Sanitarium_WL.pm";
require "Comment_WL.pm";
require "lang.pl";
require "cfg.cfg";
};
#....If not Libraries
if ($@){
	print "Content-type: text/html\n\n";
	print "ERROR including libraries: $@";
	exit;
	}
#flock() options:
$Sanitarium_WL::USE_FLOCK=$use_flock;
$Sanitarium_WL::USE_FLOCK||=0;
$Comment_WL::USE_FLOCK=$use_flock;	
$Comment_WL::USE_FLOCK||=0;	
$ENV{'SCRIPT_NAME'}=$comadmin_cgi_url;
	
#Validate DB:
$validate_db="$data/comments/new_comments.txt";
		
#....RUN main subrouting	
eval {
&main
};
#....If Errors
if ($@){ 
&WLerr("Error: $@");
}
exit;

sub main {
#-------------------------------------------------------------
if ($ENV{'REQUEST_METHOD'}){%in=&parse_form;}

if ($in{'list_new'}||$in{'list'})         {&list_new;}
elsif ($in{'modify'})                     {&modify;}
elsif ($in{'article_coms'}||$in{'view'})  {&view;}
elsif ($in{'validate'})                   {&validate;}
elsif ($in{'delete'})                     {&delete_it;}
elsif ($in{'save_modify'})                {&save_modify;}
else {&list_new;}
#end sub
}	

sub list_new {
#----------------------------------------------------------
my ($from, $to, $how, $how_pages, $span_html, $i, @new_coms);
if (-e $validate_db){
	open(NEWCOM, "<$validate_db")||&WLerr("Can not open $validate_db, reason: $!");
	if ($use_flock){flock(NEWCOM, 1);}
	@new_coms=<NEWCOM>;
	close NEWCOM;
}
unless (@new_coms){&msg($msg{'no_comments'})};
$in{'page'}||=1;
$how=$#new_coms;
	$from=$coms_per_page*($in{'page'}-1);
	$to=$from+$coms_per_page-1;
	if ($from>$how){$from=0;}
	if ($to>$how){$to=$how;}
	#How Pages:
	$how++;
	$how_pages = int ($how/$coms_per_page);
	++$how_pages unless (($how_pages*$coms_per_page) == $how);
	#Generate span pages:
	foreach my $i(1..$how_pages){
	     
		if ($in{'page'}==$i){$span_html .= qq~<font class="span"> $i </font>~;}
		else {$span_html .= qq~
		<a href="$comadmin_cgi_url?list_new=1\&page=$i" class="span"> $i </a>
		~;}
	}	
	$span_html||=' 1';
	$|++;
	&head;
	print qq~
	<form action="$ENV{'SCRIPT_NAME'}" METHOD="POST">
	<input type=hidden name="page" value="$in{'page'}">
	~;
#_________PRINT COMMENTS:
foreach my $rec (@new_coms[$from..$to]){
		$i++;
		my ($art_id, $com_id, $com)=split(/\|/, $rec);
		my $rad_name=$art_id.'id'.$com_id;
		$com .= qq~
		<br>
		<a href="$comadmin_cgi_url?id=$art_id&com_id=$com_id&modify=1" class="span">:$msg{'modify'}::$msg{'answering'}</a> 
		<br><input type=radio name="$rad_name" value="save">$msg{'validate'}
		<br><input type=radio name="$rad_name" value="delete">$msg{'delete'}
		~;
		&table("$msg{'comment'} #".$i, $com);
}	
print qq~
<font class="txt"><b>$msg{'Pages'}</b> $span_html</font><br>
<input type=SUBMIT name="validate" value="$msg{'save_it'}" class="form1"></form>
~;
&foot;
}

sub validate {
#---------------------------------------------------
my ($obj, %delete, %ok, @ids, @old_coms, @new_coms, %check);
foreach my $key (keys %in){
	unless ($key=~/^\d+id\d+/){next;}
	my ($art_id, $com_id)=split(/id/, $key);
#_______4SAVE:
	if ($in{$key} eq 'save'){
		$ok{$com_id}=$art_id;
		$check{$com_id}='';
	}
#________4DELETE:	
	elsif ($in{$key} eq 'delete'){
		$delete{$com_id}=$art_id;
	    $check{$com_id}='';
	}
}
#____SAVE OK COMMENTS
if (%ok){
	foreach my $key (keys %ok){
		$obj=new Comment_WL("$data/comments/$ok{$key}.txt");
		$obj->modify($key, 'status', 'ok');
		$obj=0;	
	}	
}
#____DELETE COMMENTS:
if (%delete){
	foreach my $key (keys %delete){
		$obj=new Comment_WL("$data/comments/$delete{$key}.txt");
		$obj->del_it($key);
		$obj=0;	
	}	
}
undef %ok;
undef %delete;
#____DELETE FROM Validate-List:
open(NEWCOM, "<$validate_db")||&WLerr("Can not open $validate_db, reason: $!");
	if ($use_flock){flock(NEWCOM, 1);}
	@old_coms=<NEWCOM>;
close NEWCOM;

foreach my $elm(@old_coms){
	push(@new_coms, $elm) unless (($elm=~/\|(\d+)\|/)&&(exists $check{$1}));
}	
open(NEWCOM, ">$validate_db")||&WLerr("Can not open $validate_db, reason: $!");
	if ($use_flock){flock(NEWCOM, 2) or &WLerr("Can not flock $validate_db, reason: $!");}
	print NEWCOM @new_coms;
close NEWCOM;


print "Location: $comadmin_cgi_url?list_new=1 \n\n";
#end sub 
}	


sub modify {
#-------------------------------------------------------------
my $obj = new Comment_WL("$data/comments/$in{'id'}.txt");
my %com=$obj->get_data($in{'com_id'});
$obj=0;
#Now get article info
$obj= new Sanitarium_WL("$data/index", 'index');
my %art=$obj->get_data($in{'id'});
$obj=0;
unless (%com){&msg("Can not get comments data, article id: $in{'id'}, comment id: $in{'com_id'}");}
$com{'content'}=&from_db_to_form($com{'content'});
if ($com{'admin_answer'}){
	$com{'admin_answer'} =&from_db_to_form($com{'admin_answer'});#<div class="admin">text</div> -> text
}
&head;
print qq~
<form action="$ENV{'SCRIPT_NAME'}" METHOD="POST">
<input type=hidden name="id" value="$in{'id'}">
<input type=hidden name="com_id" value="$in{'com_id'}">
~;
&table($msg{'info'}, qq~
<li> <b>$art{'title'}</b>
<li> <b>$msg{'Article_ID'}:</b> $art{'id'}
<li> <b>Comment ID:</b> $com{'id'}
<li> <b>$msg{'status'}:</b> $com{'status'}
<li> <b>$msg{'Date'}:</b> $com{'date'}
<li> <b>ip:</b> $com{'ip'}
<p>
<a href="$comadmin_cgi_url?view=1&id=$in{'id'}">:$msg{'view_art_coms'}</a><br>
<a href="$comadmin_cgi_url?delete=1&id=$in{'id'}&com_id=$in{'com_id'}">:$msg{'delete'}</a>
~);

#&input_form($iname, $size, $max, $val);
&table($msg{'Author'}, &input_form('name', 70, 70, $com{'name'}));
&table($msg{'mail'}, &input_form('mail', 70, 70, $com{'mail'}));
&table($msg{'www'}, &input_form('www', 70, 70, $com{'www'}));
&table($msg{'comment'}, &textarea('content', 50, 10, $com{'content'}));
&table($msg{'admin_answer'}, &textarea('admin_answer', 50, 10, $com{'admin_answer'}));
print qq~ <input type=CHECKBOX name="mailansw" value=1 CHECKED> <font class=news>$msg{'mailansw'}</font>~ if ($com{'mail'});
print qq~<br>
<input type=SUBMIT name="save_modify" value="$msg{'save_it'}" class="form1"></form>
~;
}	

sub save_modify {
#--------------------------------------------
my ($obj, $admin_answ, @old_coms, @new_coms);
unless($in{'name'}){&msg("Not defined Author's Name!<br> $msg{'back'}");}
unless($in{'id'}){&msg("Error: Not defined article\'s ID!<br> $msg{'back'}");}
unless($in{'com_id'}){&msg("Error: Not defined comment\'s ID!<br> $msg{'back'}");}
#__PARSE COMMENT:
$in{'content'} =&all_parse($in{'content'});
if ($in{'admin_answer'}){

	$admin_answ= qq~<div class="admin"><b>$msg{'answer'}</b> ~; 
	$admin_answ .= &all_parse($in{'admin_answer'});
	$admin_answ .="</div>";
}
else {$admin_answ='';}		
$obj= new Comment_WL("$data/comments/$in{'id'}.txt");
$obj->modify($in{'com_id'},
             'status', 'ok',
             'name', $in{'name'},
             'mail', ($in{'mail'}||''),
             'www', ($in{'www'}||''),
             'content', $in{'content'},
             'admin_answer', $admin_answ);
$obj=0;
#Delete from validate list
if (-e $validate_db){
	open(NEWCOM, "<$validate_db")||&WLerr("Can not open $validate_db, reason: $!");
		if ($use_flock){flock(NEWCOM, 1);}
		@old_coms=<NEWCOM>;
	close NEWCOM;
  		 @new_coms=grep(!/\|$in{'com_id'}\|/,@old_coms);#delete selected recs
  		 #if (@new_coms){
  		 open(NEWCOM, ">$validate_db")||&WLerr("Can not open $validate_db, reason: $!");
		 if ($use_flock){flock(NEWCOM, 2) or &WLerr("Can not flock $validate_db, reason: $!");}
		 print NEWCOM @new_coms;
		 close NEWCOM;
}	 
#} 
if ($in{'mailansw'}){&mailansw;}          
print "Location: $comadmin_cgi_url?view=1&id=$in{'id'} \n\n";
}	

sub view {
#--------------------------------------------
my ($obj, $html,$i, $from, $to, $how,$span_html,$how_pages, @coms, %art, %com);
$in{'page'}||=1;
$obj= new Sanitarium_WL("$data/index", 'index');
%art = $obj->get_data($in{'id'});
$obj=0;
unless (-e "$data/comments/$in{'id'}.txt"){&msg($msg{'no_comments2'});}
$obj= new Comment_WL("$data/comments/$in{'id'}.txt");
@coms=$obj->get_me_recs();
unless (@coms){&msg($msg{'no_comments2'});}
$|++;
&head;
#Now Print short article info
$html= qq~
<li> <b>$msg{'Article_ID'}:</b> $in{'id'}
<li> <b>$msg{'Title'}:</b> $art{'title'}
<li> <b>$msg{'Date'}:</b> $art{'date'}
<p>
:<a href="$view_cgi_url?cat_id=$art{'cat_id'}&id=$in{'id'}&page=1" target=_blank>$msg{'view'}</a> 
<a href="$script_admin?cat_id=$art{'cat_id'}&id=$in{'id'}&modify=1">:$msg{'modify'}:</a> 
~;
&table($msg{'info'}, $html);

$how=$#coms+1;
	$from=10*($in{'page'}-1);
	$to=$from+$coms_per_page-1;
	if ($from>$how){$from=0;}
	if ($to>$how){$to=$how;}
	#How Pages:
	$how_pages = int ($how/$coms_per_page);
	++$how_pages unless (($how_pages*$coms_per_page) == $how);
	#Generate span pages:
	foreach my $i(1..$how_pages){
		if ($in{'page'}==$i){$span_html .= qq~<font class="span"> $i </font>~;}
		else {$span_html .= qq~
		<a href="$comadmin_cgi_url?view=1&id=$in{'id'}&page=$i" class="span"> $i </a>
		~;}
	}	
	$span_html||=' 1';
foreach my $com(@coms){
	$i++;
	%com=$obj->unpack_to_hash($com);
	$html = qq~
	<li> <b>id:</b> $com{'id'}
	<li> <b>$msg{'Author'}:</b> $com{'name'}
	<li> <b>$msg{'Date'}:</b> $com{'date'}
	<p>
	$com{'content'}
	~;
	if ($com{'admin_answer'}){
		$html .= qq~
		<br>
		$com{'admin_answer'}
		~;
	}
	$html .= qq~
	<br>	
	<a href="$comadmin_cgi_url?modify=1&id=$in{'id'}&com_id=$com{'id'}" class="span">:$msg{'modify'}::$msg{'answering'}</a>	
	 <a href="$comadmin_cgi_url?delete=1&id=$in{'id'}&com_id=$com{'id'}"> :$msg{'delete'}</a>
	~;
	&table("$msg{'comment'} #".$i, $html);
}	
print "$msg{'page'}: $span_html";
&foot;
}	

sub delete_it {
#--------------------------------------------
my ($obj, $html, @old_coms, @new_coms, %com);
$obj = new Comment_WL("$data/comments/$in{'id'}.txt");
if (!$in{'y_del'}){
	%com=$obj->get_data($in{'com_id'});
	$obj=0;
	&head;
	$html = qq~
	<li> <b>id:</b> $com{'id'}
	<li> <b>$msg{'Author'}:</b> $com{'name'}
	<li> <b>$msg{'Date'}:</b> $com{'date'}
	<p>
	$com{'content'}
	~;
	if ($com{'admin_answer'}){
		$html .= qq~
		<b>$msg{'answer'}:</b><br>
		$com{'admin_answer'}
		~;
	}
	$html .= qq~
	<br>	
	<b>$msg{'q_del_com'}</b><br>
	<a href="$comadmin_cgi_url?delete=1&id=$in{'id'}&com_id=$in{'com_id'}&y_del=1"><b>$msg{'y_del_com'}</b></a>
	~;
	&table($msg{'you_sure'}, $html);
}	
else {
	$obj->del_it($in{'com_id'});
	#Delete from validate list
	if (-e $validate_db){
		open(NEWCOM, "<$validate_db")||&WLerr("Can not open $validate_db, reason: $!");
		if ($use_flock){flock(NEWCOM, 1);}
		@old_coms=<NEWCOM>;
		close NEWCOM;
  			 @new_coms=grep(!/\|$in{'com_id'}\|/,@old_coms);#delete selected recs
  			 #if (@new_coms){	
 			 open(NEWCOM, ">$validate_db")||&WLerr("Can not open $validate_db, reason: $!");
			 if ($use_flock){flock(NEWCOM, 2) or &WLerr("Can not flock $validate_db, reason: $!");}
			 print NEWCOM @new_coms;
			 close NEWCOM;
	}		 
	#} 
print "Location: $comadmin_cgi_url?article_coms=1&id=$in{'id'} \n\n";
}
}

sub all_parse {
#---------------------------------------------
my $text=shift;
$text=~s/\r//g;
$text=~s/\n\n+/<p>/g;
$text=~s/\n/<br>/g;
$text=~s/\s+/ /g;
$text =~ s/</\&lt;/g;
$text =~ s/>/\&gt;/g;
$text =~ s/"/\&quot;/g;
$text =~ s/\[(i|I)\]/<i>/g;
$text =~ s/\[\\(i|I)\]/<\/i>/g;
$text =~ s/\[(b|B)\]/<b>/g;
$text =~ s/\[\/(b|B)\]/<\/b>/g;
$text =~ s/\[(([qQ](uot|UOT|uot)[eE]?)|([cC](ite|ITE)))\]/<div class="quot">/g;
$text =~ s/\[\/(([qQ](uot|UOT|uot)[eE]?)|([cC](ite|ITE)))\]/<\/div>/g;
#$text =~ s/[^"=]\s((http|ftp):\/\/(\S+))/ <a href="$1" target=_blank>$3<\/a>/g;
if ($use_emoticons){
	$text =~ s/\s\Q:)\E\s/ <img src=$img_url\/smile\.gif width=15 height=15 alt=":)"> /g;
	$text =~ s/\s\Q:-)\E\s/ <img src=$img_url\/smile\.gif width=15 height=15 alt=":-)"> /g;
	$text =~ s/\s\Q:-(\E\s/ <img src=$img_url\/sad.gif width=15 height=15 alt=":-("> /g;
	$text =~ s/\s\Q:(\E\s/ <img src=$img_url\/sad.gif width=15 height=15 alt=":("> /g;
	$text =~ s/\s\Q8)\E\s/ <img src=$img_url\/cool.gif width=15 height=15 alt="8)"> /g;
}
return $text;
}	

sub mailansw {
#---------------------------------------------
unless ($in{'mail'}=~/(^|\s)([\w\d_-]+@[\w\d_-]+(\.[\w\d_-]+)*?\.\w{2,4})($|\s)/){return 0;}
$in{'admin_answer'}=~s/\r|(\n+)/\n/g;
open (MAIL,"| $SEND_MAIL -t -oi");
print MAIL "To: $in{'mail'}\n";
    print MAIL "From: $admin_mail\n";
    print MAIL "Reply-to: $admin_mail\n";
    print MAIL "X-Mailer: Sanitarium WebLoG (WebScript.Ru Network)\n";
    print MAIL "Content-Type: TEXT/HTML; charset=$msg{'mail_charset'}\n";
    print MAIL "Subject: $site_title $msg{'admin_answer'}\n\n";
    print MAIL "$msg{'adminansw'}<br><a href=\"$comment_url?id=$in{'id'}\">$comment_url?id=$in{'id'}</a><p>\n\n$msg{'admin_answer'}:<br>\n$in{'admin_answer'}\n";
    print MAIL "\n.\n";
close(MAIL);
}	



sub from_db_to_form {
#---------------------------------------------
my $text=shift;
$text =~ s/<.*?class="admin"><b>$msg{'answer'}<\/b>(.*?)<\/div>/$1/;
$text =~ s/<.*?class="quot">(.*?)<\/div>/\[quot\]\n$1\n\[\/quot\]/g;#<div class="quot">text</div> -> [quot]text[/quot]
$text=~ s/\s\<img src=.*?alt="(\W+)"\>\s/ $1 /g;#Emoticons parsing
$text=~s/<p>/\n\n/g;
$text=~s/<br>/\n/g;
$text =~ s/<[iI]>/\[i\]/g;#<i> -> [i]
$text =~ s/<\/[iI]>/\[\/i\]/g;#</i> -> [/i]
$text =~ s/<[bB]>/\[b\]/g;#<b> -> [b]
$text =~ s/<\/[bB]>/\[\/b\]/g;#</b> -> [/b]
return $text;
#end sub
}



#........#HTML
##############

sub head {
#--------------------------------------------------------------
&print_header;
&head_html;
print qq~
<table cellpadding=0 cellspacing=0 border=0  width="100%" height="100%">
<tr><td valign=top width=200 class="td1" rowspan=2>
<table cellpadding=0 cellspacing=5 border=0 width=200>
<tr><td valign=top>
<DIV class="red">
&raquo; $msg{'2'}
<li><a href="$script_admin?new_article=1">$msg{'3'}</a>
<li><a href="$script_admin?search_view=1">$msg{'4'}</a>
<p>

&raquo; $msg{'6'}
<li><a href="$script_admin?new_cat=1">$msg{'7'}</a>
<li><a href="$script_admin?view_category=1">$msg{'4'}</a>
<p>

&raquo; $msg{'14'}
<li><a href="$upload_url" target="newWindow"  onclick="window.open('$upload_url','newWindow','toolbar=yes, location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width=300,height=320'); return false">$msg{'menu_upload'}</a>
<li><a href="$script_admin?list_files=1" target="newWindow"  onclick="window.open('$script_admin?list_files=1','newWindow','toolbar=yes, location=0,directories=0,status=0,menubar=0,scrollbars=yes,width=400,height=320'); return false">$msg{'view_file'}</a>
<li><a href="$script_admin?delete_files=1" target="newWindow"  onclick="window.open('$script_admin?delete_files=1','newWindow','toolbar=yes, location=0,directories=0,status=0,menubar=0,scrollbars=yes,width=400,height=320'); return false">$msg{'file_delete'}</a>
<p>


&raquo; $msg{'author_menu'}
<li><a href="$script_admin?add_author=1">$msg{'author_menu_1'}</a>
<li><a href="$script_admin?view_author=1">$msg{'author_menu_2'}</a>
<p>

&raquo; $msg{'8'}
<li><a href="$script_admin?new_template=1">$msg{'9'}</a>
<li><a href="$script_admin?modify_template=1">$msg{'4'}</a>
<li><a href="$script_admin?view_template=1">$msg{'10'}</a>
<p>

&raquo; $msg{'666'}
<li><a href="$script_admin?search_view=1">$msg{'666_1'}</a>
<li><a href="$script_admin?view_category=1">$msg{'666_2'}</a>
<li><a href="$script_admin?rebuild_all=1">$msg{'666_3'}</a>
<p>
~;

if ($premoderate){
print qq~
&raquo; $msg{'com_menu'}
<li><a href="$comadmin_cgi_url?list=1">$msg{'com_edit'}</a>
<p>
~;
}	
print qq~
&raquo; $msg{'13'}
<li><a href="http://webscript.ru/sanitarium">$msg{'11'}</a>
<li><a href="http://forums.webscript.ru">$msg{'12'}</a>
<p>
</td></tr></table></td><td valign=top>
<table cellpadding=0 cellspacing=5 border=0  width="100%">
<tr><td width="100%">
<!-- main start-->
~;
}


sub head_html {
#--------------------------------------------------------------
print qq~
<html>
<head>
	<title>Sanitarium WebLoG - Admin Tools</title>
	$msg{'charset'}
~;
print &css_style;
print qq~
</head>
<body  topmargin=0	leftmargin=0 marginwidth=0 marginheight=0 bgcolor="#FFFFFF" text="#000000" link="#000000" alink="#b90000">
~;
}

sub css_style {
#--------------------------------------------------------------
return qq~
<STYLE TYPE="text/css">
body {
	 background-color:#FFFFFF;
	 color:#000000;
	 font-family:Verdana, Arial, "sans-serif";
     font-size: 10pt;
	 }
a {
  color:#000000;
  font-family:Verdana, Arial, "sans-serif";
  font-size: 10pt;
  text-decoration:none;
  
  }
a:link {text-decoration:none;}
a:hover {color:#b90000;
		text-decoration:none;
		}  
a:active {color:#b90000; text-decoration:underline;}		

.form0 {
	background-color:#f0f0f0;
	border:#000000 1 solid;
	color:#000000;
	font-size: 8pt;
	}
.form1 {
	background-color:#c0c0c0;
	border:#000000 1 solid;
	color:#000000;
	font-size: 8pt;
	}
.form2 {
	background-color:#f0f0f0;
	border:#000000 1 solid;
	color:#000000;
	font-size: 10pt;
	}
.txt {
      color:#000000;
	  font-family:Verdana, Arial, "sans-serif";
      font-size: 10pt;
	  margin-left: 10px;
	  margin-right: 10px;
	  text-align:justify;
	  line-height: 1.4em;
	  }

.news {
	  color:#000000;
	  font-family:Verdana, Arial, "sans-serif";
      font-size: 8pt;
	  }	
ul {list-style-type:circle;
    color:#b90000;
	list-style-position:inside;
	margin-left:5px;}	

.td0 { background-color:#dddddd;
	   color:#b90000;
	   font-family:Arial, "sans-serif";
   	   font-size: 10pt;
	   font-weight:bold;
   	   }
 .red {color:#b90000;
	  font-size:10pt;
	  font-weight:bold;
	  }
.td1 {
	background-color:#f0f0f0;
	border:#000000 1px solid;
	color:#000000;
	font-size: 8pt;
}	         
</STYLE>
~;
}	 


sub foot {
#--------------------------------------------------------------		
print qq~
<!-- main end-->
</DIV>
</td></tr></table></td></tr>
<tr><td valign=bottom NOWRAP><center><font class="txt"> 2001 &copy; <a href="mailto:gnezdo\@webscript.ru">Green Kakadu</a> (<a href="http://webscript.ru">WebScript.Ru Network</a>) All Rights Reserved</font></center>
</td></tr>
</table>
</body>
</html>
~;
}


sub table {
#--------------------------------------------------------------
my ($title, @content);
$title=shift;
@content=@_;
print qq~
<table cellpadding=0 cellspacing=0 border=0 class="td0" width="100%">
<tr><td width="100%">\&nbsp;|| $title </td></tr><tr><td>
<table cellpadding=5 cellspacing=1 border=0  width="100%">
<tr><td width="100%" bgcolor="#FFFFFF" class="txt">
@content
</td></tr></table></td></tr></table><br>
~;
}

sub input_form {
#--------------------------------------------------------------
#my ($iname, $size, $max, $val)=@_;
my $val=$_[3];
if ($val) {$val=&for_form($val);}
else {$val='';}
return qq~
<input type=text name="$_[0]" value="$val" size="$_[1]" maxlength="$_[2]" class="form0"><br>
~;
}

sub textarea {
#--------------------------------------------------------------
my ($fname, $cols, $rows, $val)=@_;
if ($val) {$val=&for_form($val);}
else {$val='';}
return qq~	
<textarea name="$fname" cols="$cols" rows="$rows" class="form2">$val</textarea>
<br>
~;
}

sub drop_list {
#-------------------------------------------------------------
my ($name, $mylist, $selected,  %list );
$name=shift;
$selected=shift;
$selected||='';
%list=@_;
$mylist= qq~<select name=$name size=1 class="form0">~;
foreach my $key(keys %list){
	if ($key eq $selected){$mylist .= qq~<option SELECTED value=$key class="form0">$list{$key}~;}	
	else { $mylist .= qq~<option value=$key class="form0">$list{$key}~;}
}
$mylist .= qq~</select>~;
return $mylist; 
}	

sub for_form {
#---------------------------------------------
my $text=shift;
$text =~ s/<[pP]>/\n\n/g;
$text =~ s/<[bB][rR]>/\n/g;
$text =~ s/&nbsp;/  /g;
$text =~ s/</&lt;/g;
$text =~ s/>/&gt;/g;
$text =~ s/"/&quot;/g;
return $text;
}

######################## UTILITES ############################
sub print_header {
#--------------------------------------------------------------	
print "Content-type: text/html\n";
print "Pragma: no-cache\n\n";
}

sub parse_form {
#--------------------------------------------------------------
my ($buffer, $val, $key, $line_parse, @parse, %parse_data);

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	@parse = split(/&/, $ENV{'QUERY_STRING'});
    }
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @parse = split(/&/, $buffer);
    }
else {&WLerr("This cant access (Telnet/SHH?)!");}
foreach $line_parse(@parse) {
$line_parse =~ tr/+/ /;
($key, $val) = split(/=/, $line_parse);
$key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
if (defined($parse_data{$key})){$parse_data{$key} .= ",$val";}
else {$parse_data{$key} = $val;}
}
return %parse_data;
}


sub WLerr {
#--------------------------------------------------------------
&print_header;
print @_;
exit;
}

sub msg {
#----------------------------------------------------------
&head;
&table($msg{'att'}, @_);
&foot;
exit;
}




